#ifndef __SMACKRO_BI__
#define __SMACKRO_BI__

'' ------------------------------------------------------------------
''  Copyright (C) 2007-2008, Jeff Marshall (coder@execulink.com)
''
''  This library is free software; you can redistribute it and/or
''  modify it under the terms of the GNU Lesser General Public
''  License as published by the Free Software Foundation; either
''  version 2.1 of the License, or (at your option) any later version.
''
''  This library is distributed in the hope that it will be useful,
''  but WITHOUT ANY WARRANTY; without even the implied warranty of
''  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
''  Lesser General Public License for more details.
''
''  You should have received a copy of the GNU Lesser General Public
''  License along with this library; if not, write to the Free Software
''  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
''  MA  02110-1301  USA
'' ------------------------------------------------------------------

	declare sub MacroSetVar( byref n as string, byref v as string, byval noclear as integer = 0 )
	declare function MacroGetVar( byref n as string ) as string
	declare function MacroEval( byref text as string ) as string

	declare function MacroExec( byval nargs as integer, args() as string ) as string

	declare sub MacroBind _
		( _
			byref n as string, _
			byval func as function( byval nargs as integer, args() as string ) as string, _
			byval minargs as integer _
		)

	'' helper macros for defining macro functions
	#define DEFINE_MACRO_FUNC( n ) function macro_rt_##n( byval nargs as integer, args() as string ) as string
	#define END_MACRO_FUNC end function
	#define BIND_MACRO_FUNC( n, minargs ) MacroBind( #n, @macro_rt_##n, minargs )

	declare sub MacroInit()
	declare sub MacroClearVars()
	declare sub MacroClearFuncs()

#endif
