#include once "smackro.bi"

sub DoTest( byref text as string )
	print "TEXT  : " & text
	print "RESULT: " & MacroEval( text )
	print
end sub

MacroInit()

MacroSetVar( "A", "Hello" )
MacroSetVar( "B", "World" )
MacroSetVar( "X", "_This_Is_X_" )
MacroSetVar( "Y", "$(x)" )

print "A = "; MacroGetVar( "A" )
print "B = "; MacroGetVar( "B" )
print "X = "; MacroGetVar( "X" )
print "Y = "; MacroGetVar( "Y" )
print

DoTest "Just some plain old text"
DoTest "$$(Y) = $(Y)"
DoTest "$(ucase aa $(Y) zz)"
DoTest "$(lcase aa $(Y) zz)"
DoTest "$(left some text,6)"
DoTest "$(right some text,6)"
DoTest "$(concat $(A), ,$(B))"


'' Define a custom macro function
DEFINE_MACRO_FUNC( myfunc )
  dim i as integer
  print "Function Name = "; args(0)
  print "Number of args = "; nargs
  for i = 1 to nargs - 1
    print "arg " & i & " = "; args(i)
  next
  function = "myresult"
END_MACRO_FUNC


'' Bind the macro function so we can use it
BIND_MACRO_FUNC( myfunc, 0 )


'' Test the custom macro function
dim ret as string, expr as string

expr = "$(myfunc arg1,arg2,arg3)"

print "TESTING: "; expr
print

ret = MacroEval( expr )
print "Result = "; ret

